/******************************************************************
   "keypad_ck06.c"
    -06   
       T0      
   1.01    2009  21
     
   :
          keypad_ck06.h
          keypad_ck06.c
  
******************************************************************/ 

/***     *********************************
vvvvvvv
//                                                                  
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
    KeyOut=KeyPadCK06();
}  
^^^^^^^
******************************************************************/


//      
#define  KEYPAD_PORT PORTB      //
#define  KEYPAD_DDR  DDRB       //
#define  KEYPAD_PIN  PINB       // 

void KeyInit( void )
{ 
    KEYPAD_PORT=0xF0;
    KEYPAD_DDR=0x0F;   
    
    // Timer/Counter 0 initialization
    ASSR=0x00;
    TCCR0=0x0D;
    TCNT0=0x00;
    OCR0=0x15; 
    TIMSK=0x02;
        
}

unsigned char KeyPadCK06( void )
{ 
static unsigned char KeyDn[20];
static unsigned char KeyDnShift;
static unsigned char KeyDnTemp;
static unsigned char KeyStep,KeyOutTemp,KeyTemp,KeyTemp2;  
static unsigned char KeyBit; 

    TCNT0=0x00; //  
    
    //delay_us(1);
  
    KeyTemp=(0b11110000&KEYPAD_PIN);
    //   SHIFT
    if(KeyStep==0)
    {   if((~(KeyTemp|0b11101111))!=0)
        {
            if(KeyDnShift==3) 
            {
                KeyBit=1;
            }
            else
            {
                KeyDnShift++; 
            }
        }
        else
        {
            KeyBit=0;
            KeyDnShift=0;
        }
        KeyTemp|=0b00010000;
    }  
    switch (KeyTemp)
    {
        case 0b11100000 :
            KeyTemp2=KeyStep*4;
            if(KeyDn[KeyTemp2]==3) 
            {
                KeyOutTemp=KeyTemp2+1+16*KeyBit;
            }
            else
            {
                KeyDn[KeyTemp2]++; 
            }   
            break;
        case 0b11010000 :
            KeyTemp2=KeyStep*4+1;
            if(KeyDn[KeyTemp2]==3) 
            {
                KeyOutTemp=KeyTemp2+1+16*KeyBit;
            }
            else
            {
                KeyDn[KeyTemp2]++; 
            }
            break;
        case 0b10110000 :
            KeyTemp2=KeyStep*4+2;
            if(KeyDn[KeyTemp2]==3) 
            {
                KeyOutTemp=KeyTemp2+1+16*KeyBit;
            }
            else
            {
                KeyDn[KeyTemp2]++; 
            }
            break;
        case 0b01110000 :
            KeyTemp2=KeyStep*4+3;
            if(KeyDn[KeyTemp2]==3) 
            {
                KeyOutTemp=KeyTemp2+1+16*KeyBit;
            }
            else
            {
                KeyDn[KeyTemp2]++; 
            }
            break;
        default:
            KeyTemp2=KeyStep*4;
            KeyDn[KeyTemp2++]=0;
            KeyDn[KeyTemp2++]=0;
            KeyDn[KeyTemp2++]=0;
            KeyDn[KeyTemp2]=0;
            KeyDnTemp++;
            
            
    };
    
    if(KeyStep==3)
    {   
        //KeyOutTemp=KeyOutTemp+16*KeyBit;
        if(KeyDnTemp!=3)
        {
            if(KeyBit)
            {KeyOutTemp=1;}
            else    
            {KeyOutTemp=0;} 
        }
        if(KeyOutTemp==20)
        {KeyOut=4;}
        else 
        {KeyOut=KeyOutTemp;}
    }
    KeyStep++;
    if (KeyStep>3) {KeyStep=0; KeyDnTemp=0;}
    KEYPAD_PORT&= 0b11110000;
    KEYPAD_DDR&=0b11110000;
    KEYPAD_DDR|=(1<<KeyStep); 
    return KeyOut;   
}
 
//   
unsigned char Key( void )
{
    while(KeyOut==0);
    return KeyOut;
}

//   
void KeyNul( void )
{
    while(KeyOut!=0);
}
